import sys

def update(table, t0, start, end, bytes):
  # compute how many bits per second there are for each second
  bps=8 * bytes / (int(end)-int(start) + 1)
  try:
    for sec in range(int(start), int(end) + 1):
      table[sec-int(t0)] += bps
  except IndexError:
    print('Seconds was not within table bounds (0-%d):\n sec=%d\n  t0=%d'%(len(table), sec, int(t0)), file=sys.stderr)
    raise
  return

# Simple manual test function to play around
# In reality would read flow records from a file in a loop

def test():
  # minimum timestamp (here 1970-01-01T00:01:40 but you would set it to start of capture 
  t0=100
  # our analysis only 20 seconds long
  tbl=[0.0]*20
  # first flow, over 10 seconds, 600 bytes (4800 bits) per second
  update(tbl, t0, 100.2, 109.8, 6000)
  print(tbl) # print array content
  # second flow over 8 seconds, partly overlaps with one earlier
  update(tbl, t0, 108.9, 115.5, 12000)
  # a 0 s length flow
  update(tbl, t0, 119.4, 119.4, 40)
  print(tbl)
  # uncomment following lines to trigger an error
  update(tbl, t0, 118.9, 125.5, 12000)
  print(tbl)

test()
